package org.dronus.graph.gui.interact;

import java.awt.*;
import java.util.*;
class RollbackPopupMenu extends PopupMenu{
	HashSet temp=new HashSet();
	boolean rollback=false;
	RollbackPopupMenu(String _label){
		super(_label);
	}	
	public MenuItem add(MenuItem i) {
		temp.add(i); 		
		return super.add(i);		
	}
	public void mark(){
		if(rollback) doRollback();
		else temp=new HashSet();		
	}
	public void rollback(){
		//kein Instant-Rollback, da es dem EventHandler nicht schmeckt (Source fehlt dann)
		rollback=true;		
	};
	private void doRollback(){
		Iterator i=temp.iterator();
		while(i.hasNext())
			remove((MenuItem)i.next());		
		rollback=false;
		mark();
	};
	public void show(Component origin, int x, int y) {
		//rollback wenn ntig hier
		if(rollback) doRollback();
		super.show(origin, x, y);
	}
}

