/*
 * Created on 02.04.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.dronus.graph.nodefilter;

import org.dronus.graph.gui.LayoutableNode;
import org.dronus.graph.gui.Locality;
import org.dronus.graph.gui.GraphForEachNode;


/**
 * @author Paul
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public abstract class NodeFilter{
	
	abstract public boolean match(LayoutableNode n);
	public boolean isCutting(){return true;}
	
	class Inserter extends GraphForEachNode{
		Locality loc;
		Inserter(Locality _loc) {loc=_loc;}
		public void forEachNode(LayoutableNode n) {
			if (match(n)) loc.addNodeWithEdges(n);				
		}
	};
	
	
	public void applyFilter(Locality loc){
		//Locality allNodes=new Locality(loc);
		//allNodes.addAll();
		loc.removeAll();
		Inserter i=new Inserter(loc);			
		loc.getCompleteEltSet().forAllNodes(i);
	}
}