/*
 * Created on 27.05.2004
 *
*/
package org.dronus.hansi;

import java.awt.Graphics;
import java.io.File;
import java.util.*;

//import org.dronus.graph.*;
import org.dronus.graph.gui.*;


public class GraphLeinMap extends LeinMap {

	/**
	 *
	 */
	GraphPanel gp;
	HashMap nodes=new HashMap();
	public GraphLeinMap(String _blockbase, File mapfile, GraphPanel _gp) {
		super(_blockbase, mapfile);
		gp=_gp;
		gp.getVisibleLocality().getCompleteEltSet().forAllNodes(new GraphForEachNode(){
			public void forEachNode(LayoutableNode n){
				if (n.edgeCount()>0 && n.getType().equals("Punkt"))
					nodes.put(new GK(n.getLabel()), n.edgeAt(0).getOtherEndpt(n));						
			};
		}	
		);		
		
	}
	public void paint(Graphics _g) {
		if (isPainting) return;
		Graphics g=getBufferImg().getGraphics();
		g.clearRect(0,0,getWidth(),getHeight());
		isPainting=true;
		draw(g);

		int s=1<<miplevel;
		double w=getWidth(), h=getHeight();			
		int cx=(int)w/2, cy=(int)h/2;
		w/=s;h/=s;

		Iterator it=nodes.entrySet().iterator();
		while (it.hasNext()){
			Map.Entry e=(Map.Entry)it.next();
			GK gk=(GK)e.getKey();
			int x = (int)(gk.getRasterX()-posx)/s+cx;	
			int y = (int)(gk.getRasterY()-posy)/s+cy;
			((LayoutableNode)e.getValue()).draw(g,x,y,false,false);
		}					
		_g.drawImage(bufferimg,0,0,null); 		
		isPainting=false;		
	}
}
