
package org.dronus.graph;

import org.dronus.graph.gui.*;


/**
 * @author Paul
 */
public class TypeNodeRenderer extends NodeRenderer{
	public TypeNodeRenderer(LayoutableNode _n) {
		super(_n);
	}
	public void update(final Graph l){
		final LayoutableNode n2=n;
				
		GraphForEachNode fan = new GraphForEachNode(){
			public void forEachNode(LayoutableNode n1){
				if (n1!=n2 && n1.getType().equals(n2.getType()))
					l.addEdge(new LayoutableEdge(n1, n2, "ist"));
			};	
		}; 		
		l.forAllNodes(fan);
	}	
}
