/*
 * Created on 23.04.2004
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.dronus.graph.gui;

import java.awt.Graphics;
import java.awt.Image;
import java.io.File;

import org.dronus.dope.FilePool;

/**
 * @author Paul
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class FileNodeRenderer extends NodeRenderer {
	Image img;
	final static String TYPE_IMG="jpg png gif",TYPE_TEXT="txt";
	NodeRenderer renderer;
	File file;
	protected FileNodeRenderer(LayoutableNode _n) {
		super(_n);
		file=new File(n.getLabel());
		String[] split=n.getLabel().split("\\.");
		String ft=split[split.length-1].toLowerCase();		
		
		if (TYPE_IMG.indexOf(ft)>=0)	renderer=new ImageNodeRenderer(n,file);
		else if (ft.equals(TYPE_TEXT))	renderer=new TextNodeRenderer(n,file);
		else renderer=new NodeRenderer(n);
	}
	public void paint(Graphics g, int x, int y, boolean selected, boolean print) {
		renderer.paint(g,x,y,selected,print);
	}
	public void defaultAction(){
		FilePool.getDefaultPool().invoke(new File(n.getLabel()));
	}
}
